import { HexEditor } from './hex-editor';
declare type editType = "insert" | "overwrite";
declare type source = "origin" | "added" | "inprogress";
declare type piece = {
    offset: number;
    length: number;
    source: source;
};
declare type inprogress = {
    offset: number;
    type: editType;
    content: number[];
    index: number;
    length: number;
};
declare type pieces = piece | inprogress;
export declare class EditController {
    private parent;
    original: Uint8Array;
    added: Uint8Array;
    pieces: Array<pieces>;
    inProgress: inprogress;
    chunk: string;
    constructor(parent: HexEditor);
    initEdit(offset: number, type: editType): void;
    buildEdit(keyStroke: KeyboardEvent): void;
    commit(): void;
    render(start: number, length: number): {
        out: Uint8Array;
        meta: {
            added: [number, number][];
        };
    };
    readonly length: number;
    rollback(): void;
    save(): Uint8Array;
    private getPieceBuffer;
}
export {};
